<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Building with Conan &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../_static/css/custom.css?v=4ad39fc2" />
      <link rel="stylesheet" type="text/css" href="../_static/tabs.css?v=a5c4661c" />

  
    <link rel="shortcut icon" href="../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js?v=5d32c60e"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../_static/doctools.js?v=888ff710"></script>
        <script src="../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../_static/tabs.js?v=3030b3cb"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Overview" href="../user_guide/10_overview.html" />
    <link rel="prev" title="CMake Variables and Options" href="further_guidance/10_cmake.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            openPASS
              <img src="../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Building with Conan</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#general">General</a></li>
<li class="toctree-l2"><a class="reference internal" href="#additional-prerequisites">Additional Prerequisites</a></li>
<li class="toctree-l2"><a class="reference internal" href="#conan-recipes">Conan Recipes</a></li>
<li class="toctree-l2"><a class="reference internal" href="#conan-create">Conan Create</a></li>
<li class="toctree-l2"><a class="reference internal" href="#conan-install">Conan Install</a></li>
<li class="toctree-l2"><a class="reference internal" href="#build-only-thirdparties">Build only ThirdParties</a></li>
</ul>
</li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Building with Conan</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/installation_guide/60_conan.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="building-with-conan">
<span id="id1"></span><h1>Building with Conan<a class="headerlink" href="#building-with-conan" title="Link to this heading"></a></h1>
<section id="general">
<h2>General<a class="headerlink" href="#general" title="Link to this heading"></a></h2>
<p>Conan is an open source, decentralized and multi-platform package manager to create and share native binaries.</p>
<p>To learn more about Conan itself you can visit <a class="reference external" href="https://conan.io/">Conan</a>.</p>
<p>Conan is used in the <strong>openPASS</strong> project to create and manage the binaries of the used ThirdParty libraries.</p>
</section>
<section id="additional-prerequisites">
<h2>Additional Prerequisites<a class="headerlink" href="#additional-prerequisites" title="Link to this heading"></a></h2>
<p>To be able to work with Conan it is necessary to add additional packages.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-0-0-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-0-0-0" name="0-0" role="tab" tabindex="0">Windows (MSYS2)</button><button aria-controls="panel-0-0-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-0-0-1" name="0-1" role="tab" tabindex="-1">Linux (Debian Bookworm)</button></div><div aria-labelledby="tab-0-0-0" class="sphinx-tabs-panel" id="panel-0-0-0" name="0-0" role="tabpanel" tabindex="0"><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>pip<span class="w"> </span>install<span class="w"> </span><span class="s2">&quot;conan&gt;=2.2.0&quot;</span>
</pre></div>
</div>
</div><div aria-labelledby="tab-0-0-1" class="sphinx-tabs-panel" hidden="true" id="panel-0-0-1" name="0-1" role="tabpanel" tabindex="0"><div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>apt<span class="w"> </span>install<span class="w"> </span><span class="s2">&quot;conan&gt;=2.2.0&quot;</span>
</pre></div>
</div>
</div><p>pip install “conan&gt;2.0”</p>
</div>
</section>
<section id="conan-recipes">
<h2>Conan Recipes<a class="headerlink" href="#conan-recipes" title="Link to this heading"></a></h2>
<p>A <em>recipe</em> is python file, which is used by conan to build and create a package.
In this file there are several hooks available, which can be used for several tasks.
E.g. Retrieving the source files, building from source, configuring dependencies, packaging, etc.
Visit <a class="reference external" href="https://conan.io/">Conan</a>. for detailed information about <em>recipes</em>.</p>
</section>
<section id="conan-create">
<h2>Conan Create<a class="headerlink" href="#conan-create" title="Link to this heading"></a></h2>
<p>The <cite>conan create</cite> command is used to create Conan packages from source code. It involves building the source code, packaging the resulting binaries and artifacts, and generating the necessary metadata to publish the package.
The basic syntax of the command is as follows:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>conan<span class="w"> </span>create<span class="w"> </span>&lt;path_to_recipe&gt;<span class="w"> </span>--name<span class="w"> </span><span class="nv">$pkg</span><span class="w"> </span>--version<span class="w"> </span><span class="nv">$version</span><span class="w"> </span>--user<span class="w"> </span><span class="nv">$user</span><span class="w"> </span>--channel<span class="w"> </span><span class="nv">$channel</span><span class="w"> </span>--build<span class="o">=</span>missing<span class="w"> </span><span class="nv">$packageOptions</span><span class="w"> </span>-pr:a<span class="w"> </span><span class="s2">&quot;</span><span class="nv">$conanprofile</span><span class="s2">&quot;</span>
</pre></div>
</div>
<ul class="simple">
<li><p><cite>&lt;path_to_source&gt;</cite>: The path to the conan recipe of that corresponding package.</p></li>
<li><p><cite>–name $pkg</cite>: Specifies the name of the package being created. $pkg is a placeholder for the actual package name.</p></li>
<li><p><cite>–version $version</cite>: Specifies the version of the package being created. $version is a placeholder for the actual version number.</p></li>
<li><p><cite>–user $user</cite>: Specifies the username of the package creator or owner. $user is a placeholder for the actual username.</p></li>
<li><p><cite>–channel $channel</cite>: Specifies the channel or repository where the package will be published. $channel is a placeholder for the actual channel name.</p></li>
<li><p><cite>–build=missing</cite>: Instructs Conan to build the package if its dependencies are missing or outdated. This ensures that all required dependencies are available and up to date before building the package.</p></li>
<li><p><cite>$packageOptions</cite>: Optional package-specific options that can be passed to the Conan recipe. These options can customize the build process or package configuration according to user requirements.</p></li>
<li><p><cite>-pr:a “$conanprofile”</cite>: Specifies a profile ($conanprofile) to be used during package creation. Profiles define the build environment and configuration settings for building packages. The -pr:a flag tells Conan to apply this profile specifically for building the package.</p></li>
</ul>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>conan<span class="w"> </span>create<span class="w"> </span>.<span class="w"> </span>--name<span class="w"> </span>openscenario_engine<span class="w"> </span>--version<span class="w"> </span><span class="m">0</span>.1<span class="w"> </span>--user<span class="w"> </span>openpass<span class="w"> </span>--channel<span class="w"> </span>testing<span class="w"> </span>--build<span class="o">=</span>missing<span class="w"> </span>-pr:a<span class="w"> </span>default
</pre></div>
</div>
<p>This command will build the package <cite>openscenario_engine</cite> with version <cite>1.0</cite> under the user <cite>openpass</cite> and channel <cite>testing</cite>.</p>
<p><strong>Optional Settings</strong></p>
<p>The <cite>-o</cite> option allows you to pass optional settings to the <cite>conan create</cite> command, which can be used to customize the build process of the package. These settings are defined in the <cite>conanfile.py</cite> recipe.
For example, you can specify build options, compiler flags, or any other configuration settings that influence the package creation process.</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>conan<span class="w"> </span>create<span class="w"> </span>.<span class="w"> </span>--name<span class="w"> </span>openscenario_engine<span class="w"> </span>--version<span class="w"> </span><span class="m">0</span>.1<span class="w"> </span>--user<span class="w"> </span>openpass<span class="w"> </span>--channel<span class="w"> </span>testing<span class="w"> </span>--build<span class="o">=</span>missing<span class="w"> </span>-o<span class="w"> </span><span class="nv">MantleAPI_version</span><span class="o">=</span><span class="m">0</span>.1<span class="w"> </span>-o<span class="w"> </span><span class="nv">Yase_version</span><span class="o">=</span><span class="m">0</span>.1<span class="w"> </span>-pr:a<span class="w"> </span>default
</pre></div>
</div>
<p>In this example, the <cite>-o</cite> option is used to set the <cite>MantleAPI_version</cite> and <cite>Yase_version</cite> build options for the <cite>openscenario_engine</cite> package. These options will be considered during the package creation process.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>For the packages MantleAPI, Yase, openscenario_api and openscenario_engine corresponding commit ids can be used instead of version when creating the package</p>
</div>
</section>
<section id="conan-install">
<h2>Conan Install<a class="headerlink" href="#conan-install" title="Link to this heading"></a></h2>
<p>The <cite>conan install</cite> command is used to install Conan packages from a Conan recipe (a <cite>conanfile.py</cite> file) and its associated dependencies. It resolves and fetches the required packages from a remote Conan repository or local conan cache and installs them in the specified target location.
The basic syntax of the command is as follows:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>conan<span class="w"> </span>install<span class="w"> </span>--requires<span class="o">=</span>&lt;pkg/version@user/channel&gt;<span class="w"> </span>--build<span class="w"> </span>&lt;missing<span class="p">|</span>outdated&gt;<span class="w"> </span>--deployer<span class="o">=</span>&lt;generator&gt;<span class="w"> </span>-of<span class="o">=</span>&lt;install-folder-folder&gt;<span class="w"> </span>-g<span class="w"> </span>CMakeDeps<span class="w"> </span>-pr:a<span class="w"> </span><span class="s2">&quot;</span><span class="nv">$conanprofile</span><span class="s2">&quot;</span>
</pre></div>
</div>
<ul class="simple">
<li><p><cite>&lt;pkg/version&#64;user/channel&gt;</cite>: The user and channel specify the namespace under which the package with the corresponding version will be built.</p></li>
<li><p><cite>-g &lt;generator&gt;</cite>: Specifies the build system generator (e.g., <cite>CMakeDeps</cite>) for generating build files.</p></li>
<li><p><cite>-s &lt;setting=value&gt;</cite>: Overrides a Conan setting defined in the recipe with the given value.</p></li>
<li><p><cite>–build &lt;missing|outdated&gt;</cite>: Specifies whether to build missing or outdated packages.</p></li>
<li><p><cite>-pr:a “$conanprofile”</cite>: Specifies a profile ($conanprofile) to be used during package creation. Profiles define the build environment and configuration settings for building packages. The -pr:a flag tells Conan to apply this profile specifically for building the package.</p></li>
</ul>
<p><strong>Generate Deployment Files</strong></p>
<p>The <cite>-g direct_deploy</cite> option with the <cite>conan install</cite> command is used to generate deployment-related files and scripts for installing and running the package on a target system.
These files can include packaging scripts, installation scripts, and other artifacts required for deploying the package to a specific environment.</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>$<span class="w"> </span>conan<span class="w"> </span>install<span class="w"> </span>openscenario_engine/0.1@openpass/testing<span class="w"> </span>-g<span class="w"> </span>direct_deploy<span class="w"> </span>--install-folder<span class="o">=</span><span class="s2">&quot;my/installation/path&quot;</span>
</pre></div>
</div>
<p>This command will deploy the package <cite>openscenario_engine/0.1&#64;openpass/testing</cite> at the installation path.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>There are several additional commands, arguments and fields for these commands available.
Please see <a class="reference external" href="https://docs.conan.io/en/latest/">Conan Docs</a> for additional information.</p>
</div>
</section>
<section id="build-only-thirdparties">
<h2>Build only ThirdParties<a class="headerlink" href="#build-only-thirdparties" title="Link to this heading"></a></h2>
<p><strong>openPASS</strong> requires number of third parties libraries and they are listed in <code class="docutils literal notranslate"><span class="pre">conanfile.txt</span></code>. To install all the dependencies, the script <code class="docutils literal notranslate"><span class="pre">15_prepare_thirdParty.sh</span></code> can be used.</p>
<p>The exact list of dependency can be found below.</p>
<div class="highlight-text notranslate"><div class="highlight"><pre><span></span>[requires]
b2/5.0.0
boost/1.85.0
fmilibrary/2.0.3
gtest/1.14.0
libiconv/1.17
libxml2/2.11.5
mantleapi/v5.1.0
minizip/1.2.13
open-simulation-interface/3.7.0
openscenario_api/v1.3.1
openscenario_engine/v6.0.1
protobuf-shared/3.20.0
protobuf/3.20.0
units/2.3.3
yase/0.1
zlib/1.3.1

[options]
b2/*:toolset=gcc
boost/*:shared=True
boost/*:without_chrono=True
boost/*:without_cobalt=True
boost/*:without_container=True
boost/*:without_context=True
boost/*:without_contract=True
boost/*:without_coroutine=True
boost/*:without_date_time=True
boost/*:without_fiber=True
boost/*:without_iostreams=True
boost/*:without_json=True
boost/*:without_locale=True
boost/*:without_log=True
boost/*:without_nowide=True
boost/*:without_stacktrace=True
boost/*:without_test=True
boost/*:without_thread=True
boost/*:without_timer=True
boost/*:without_type_erasure=True
boost/*:without_url=True
boost/*:without_wave=True
libxml2/*:ftp=False
libxml2/*:html=False
libxml2/*:http=False
libxml2/*:include_utils=False
libxml2/*:legacy=False
libxml2/*:sax1=False
libxml2/*:shared=False
libxml2/*:zlib=False
msys2/*:no_kill=True
openscenario_engine/*:MantleAPI_version=v5.1.0
openscenario_engine/*:Yase_version=0.1
protobuf-shared/*:debug_suffix=False
protobuf/*:debug_suffix=False

[generators]
CMakeDeps
</pre></div>
</div>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="further_guidance/10_cmake.html" class="btn btn-neutral float-left" title="CMake Variables and Options" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../user_guide/10_overview.html" class="btn btn-neutral float-right" title="Overview" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>